﻿using System;
using System.Collections;

namespace ConsoleApplication1
{
    class IntegerCompare : IComparer // IComparer를 상속받는 타입 정의
    {
        // IComparer 인터페이스의 Compare 메소드를 구현.
        // 이 메소드는 Array.Sort 메소드 내에서 콜백으로 호출됨.
        public int Compare(object x, object y)
        {
            int xValue = (int)x;
            int yValue = (int)y;

            if (xValue > yValue) return -1; // 내림차순 정렬이 되도록 -1을 반환
            else if (xValue == yValue) return 0;

            return 1;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            // 문자열 출력
            int[] intArray = new int[] { 1, 2, 3, 4, 5 };

            // IComparer를 상속받은 IntegerCompare 인스턴스 전달
            Array.Sort(intArray, new IntegerCompare());
            foreach (int item in intArray)
            {
                Console.Write(item + ", ");
            }
        }
    }
}
